using System;
using System.Linq;

namespace Wsp.Types
{
	internal struct GenericConstraint : IEquatable<GenericConstraint>
	{
		public readonly Int64BasedSet StepsMask;
		public readonly int[] Steps;
		public readonly int Users;

		public GenericConstraint(int[] steps, int users)
		{
			StepsMask = new Int64BasedSet(steps);
			Steps = StepsMask.ToArray();
			Users = users;
		}

		public bool Equals(GenericConstraint other)
		{
			return StepsMask == other.StepsMask && Users == other.Users;
		}

		public override bool Equals(object obj)
		{
			if (ReferenceEquals(null, obj))
				return false;

			return obj is GenericConstraint && Equals((GenericConstraint)obj);
		}

		public override int GetHashCode()
		{
			unchecked
			{
				return (StepsMask.GetHashCode() * 397) ^ Users;
			}
		}
	}
}